require 'open-uri'
require 'jekyll-torrent/version'

# Creates a torrent file with your generated site. You should serve the files
# with your client.
module Jekyll
  class Site

    def process_with_torrent
      # Original Site.process method
      process_without_torrent
      self.make_torrent
    end

    def make_torrent
      # The torrent file is written at the root of the site
      file = "#{dest}/#{torrent['file']}"
      tracker = [torrent['announce']].flatten
      tracker = random_tracker if tracker.include? 'random'
      trackers = tracker.join(' --tracker ')

      # Delete existing file
      File.delete(file) if File.exists?(file)

      puts "Generating torrent file at #{file}"
      # TODO usar popen3
      command = "#{torrent['bin']} --tracker #{trackers} --outfile \"#{file}\" #{torrent['flags']} \"#{dest}\""
      puts command
      puts `#{command}`
    end

    def random_tracker
      open('https://ngosang.github.io/trackerslist/trackers_best.txt') do |l|
        l.read
      end.split("\n\n").sample(3)
    end

    # Alias method chain
    alias_method :process_without_torrent, :process
    alias_method :process, :process_with_torrent

    private
      # Merges config with default values
      def torrent
        @torrent_config ||= {
          'announce' => 'udp://tracker.opentrackr.org:1337/announce',
          'file'     => 'site.torrent',
          'flags'    => '',
          'bin'      => 'transmission-create'
        }.merge(config.fetch('torrent', {}))
      end
  end
end
